; asmsyntax=asm

; Copyright 2012 Peter Lebbing <peter@digitalbrains.com>
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

.altmacro
.macro delay16 hi, lo
; Call as delay16 r17, r16 when delay length argument is in (r17:r16)
;
; The complete delay loop runs for
; d = (x + 1) * 3 - 1
; cycles, where x is the 16-bit argument
;
; NOTE: x must be greater than 0!
;
; Postcondition: SREG: !H, !S, !V, !N, Z, !C

LOCAL long_delay_loop, short_delay

	tst	hi
	breq	short_delay

	subi    lo, 1 		; Correct argument
	sbci	hi, 0 		; for long delay
	nop
	nop

long_delay_loop:
	subi	lo, 2
	sbci	hi, 0
	nop
	nop
	brne	long_delay_loop
 	nop
		
short_delay:
	subi	lo, 1
	brne	short_delay
.endm

